
void log(int level, const char *fmt, ...);
void zlog(int level, int lineno, const char *fmt, ...);

struct zonedata;
struct dnspacket;
typedef unsigned ip4addr_t;

#define R_A_DEFAULT ((ip4addr_t)0x7f000002)

typedef struct zonedata *z_loadfn(FILE *f);
typedef void z_freefn(struct zonedata *zone);
typedef int
z_queryfn(const struct zonedata *const zone, struct dnspacket *p,
	  const unsigned char *const query, unsigned qflg);

#define QUERY_A   0x01
#define QUERY_TXT 0x02

/* see details of DNS packet structure in rbldnsd.c */

int addrec_a(struct dnspacket *p, ip4addr_t aip);
int addrec_txt(struct dnspacket *p, const char *txt, const char *subst);

ip4addr_t dntoip4addr(const unsigned char *q);
const char *ip4atos(ip4addr_t a);

/* list of zone types */
#define definezonetype(t) \
  z_queryfn t##_query; z_loadfn t##_load; z_freefn t##_free
#define dnset_descr "set of domain names"
definezonetype(dnset);
#define dnvset_descr "set of (domain name, value) pairs"
definezonetype(dnvset);
#define ip4set_descr "set of ip4 addresses with the same result"
definezonetype(ip4set);
#define ip4vset_descr "set of (ip4, value) pairs"
definezonetype(ip4vset);
#undef definezonetype

unsigned ip4range(const char *str, ip4addr_t *ap);
int addrtxt(char *str, ip4addr_t *ap, char **txtp);

void oom();
void *emalloc(unsigned size);
void *erealloc(void *ptr, unsigned size);
char *estrdup(const char *str);
char *esstrdup(const char *str);
struct mempool;
void *mp_ealloc(struct mempool *mp, unsigned size);
char *mp_estrdup(struct mempool *mp, const char *str);
